diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/examples/CMakeLists.txt ns-3.36/src/spectrum/examples/CMakeLists.txt
--- ns-3.35/src/spectrum/examples/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/spectrum/examples/CMakeLists.txt	2022-04-30 18:23:58.146735000 -0700
@@ -0,0 +1,57 @@
+build_lib_example(
+  NAME adhoc-aloha-ideal-phy
+  SOURCE_FILES adhoc-aloha-ideal-phy.cc
+  LIBRARIES_TO_LINK
+    ${libspectrum}
+    ${libmobility}
+    ${libinternet}
+    ${libapplications}
+)
+
+build_lib_example(
+  NAME adhoc-aloha-ideal-phy-matrix-propagation-loss-model
+  SOURCE_FILES adhoc-aloha-ideal-phy-matrix-propagation-loss-model.cc
+  LIBRARIES_TO_LINK
+    ${libspectrum}
+    ${libmobility}
+    ${libinternet}
+    ${libapplications}
+)
+
+build_lib_example(
+  NAME adhoc-aloha-ideal-phy-with-microwave-oven
+  SOURCE_FILES adhoc-aloha-ideal-phy-with-microwave-oven.cc
+  LIBRARIES_TO_LINK
+    ${libspectrum}
+    ${libmobility}
+    ${libinternet}
+    ${libapplications}
+)
+
+build_lib_example(
+  NAME tv-trans-example
+  SOURCE_FILES tv-trans-example.cc
+  LIBRARIES_TO_LINK
+    ${libspectrum}
+    ${libmobility}
+    ${libcore}
+)
+
+build_lib_example(
+  NAME tv-trans-regional-example
+  SOURCE_FILES tv-trans-regional-example.cc
+  LIBRARIES_TO_LINK
+    ${libspectrum}
+    ${libmobility}
+    ${libcore}
+)
+
+build_lib_example(
+  NAME three-gpp-channel-example
+  SOURCE_FILES three-gpp-channel-example.cc
+  LIBRARIES_TO_LINK
+    ${libspectrum}
+    ${libmobility}
+    ${libcore}
+    ${liblte}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/examples/three-gpp-channel-example.cc ns-3.36/src/spectrum/examples/three-gpp-channel-example.cc
--- ns-3.35/src/spectrum/examples/three-gpp-channel-example.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/examples/three-gpp-channel-example.cc	2022-04-30 18:23:58.146735000 -0700
@@ -51,6 +51,41 @@
 static Ptr<ThreeGppSpectrumPropagationLossModel> m_spectrumLossModel; //!< the SpectrumPropagationLossModel object
 
 /**
+ * \brief A structure that holds the parameters for the
+ * ComputeSnr function. In this way the problem with the limited
+ * number of parameters of method Schedule is avoided.
+ */
+struct ComputeSnrParams
+{
+  Ptr<MobilityModel> txMob; //!< the tx mobility model
+  Ptr<MobilityModel> rxMob; //!< the rx mobility model
+  double txPow; //!< the tx power in dBm
+  double noiseFigure; //!< the noise figure in dB
+  Ptr<PhasedArrayModel> txAntenna; //!< the tx antenna array
+  Ptr<PhasedArrayModel> rxAntenna; //!< the rx antenna array
+
+  /**
+   * \brief Constructor
+   * \param pTxMob the tx mobility model
+   * \param pRxMob the rx mobility model
+   * \param pTxPow the tx power in dBm
+   * \param pNoiseFigure the noise figure in dB
+   * \param pTxAntenna the tx antenna array
+   * \param pRxAntenna the rx antenna array
+   */
+  ComputeSnrParams (Ptr<MobilityModel> pTxMob, Ptr<MobilityModel> pRxMob, double pTxPow, double pNoiseFigure,
+                    Ptr<PhasedArrayModel> pTxAntenna, Ptr<PhasedArrayModel> pRxAntenna)
+  {
+    txMob = pTxMob;
+    rxMob = pRxMob;
+    txPow = pTxPow;
+    noiseFigure = pNoiseFigure;
+    txAntenna = pTxAntenna;
+    rxAntenna = pRxAntenna;
+  }
+};
+
+/**
  * Perform the beamforming using the DFT beamforming method
  * \param thisDevice the device performing the beamforming
  * \param thisAntenna the antenna object associated to thisDevice
@@ -93,13 +128,10 @@
 
 /**
  * Compute the average SNR
- * \param txMob the tx mobility model
- * \param rxMob the rx mobility model
- * \param txPow the transmitting power in dBm
- * \param noiseFigure the noise figure in dB
+ * \param params A structure that holds the parameters that are needed to perform calculations in ComputeSnr
  */
 static void
-ComputeSnr (Ptr<MobilityModel> txMob, Ptr<MobilityModel> rxMob, double txPow, double noiseFigure)
+ComputeSnr (ComputeSnrParams& params)
 {
   // Create the tx PSD using the LteSpectrumValueHelper
   // 100 RBs corresponds to 18 MHz (1 RB = 180 kHz)
@@ -109,23 +141,26 @@
   {
     activeRbs0[i] = i;
   }
-  Ptr<SpectrumValue> txPsd = LteSpectrumValueHelper::CreateTxPowerSpectralDensity (2100, 100, txPow, activeRbs0);
+  Ptr<SpectrumValue> txPsd = LteSpectrumValueHelper::CreateTxPowerSpectralDensity (2100, 100, params.txPow, activeRbs0);
   Ptr<SpectrumValue> rxPsd = txPsd->Copy ();
   NS_LOG_DEBUG ("Average tx power " << 10*log10(Sum (*txPsd) * 180e3) << " dB");
 
   // create the noise PSD
-  Ptr<SpectrumValue> noisePsd = LteSpectrumValueHelper::CreateNoisePowerSpectralDensity (2100, 100, noiseFigure);
+  Ptr<SpectrumValue> noisePsd = LteSpectrumValueHelper::CreateNoisePowerSpectralDensity (2100, 100, params.noiseFigure);
   NS_LOG_DEBUG ("Average noise power " << 10*log10 (Sum (*noisePsd) * 180e3) << " dB");
 
   // apply the pathloss
-  double propagationGainDb = m_propagationLossModel->CalcRxPower (0, txMob, rxMob);
+  double propagationGainDb = m_propagationLossModel->CalcRxPower (0, params.txMob, params.rxMob);
   NS_LOG_DEBUG ("Pathloss " << -propagationGainDb << " dB");
   double propagationGainLinear = std::pow (10.0, (propagationGainDb) / 10.0);
   *(rxPsd) *= propagationGainLinear;
 
+  NS_ASSERT_MSG (params.txAntenna, "params.txAntenna is nullptr!");
+  NS_ASSERT_MSG (params.rxAntenna, "params.rxAntenna is nullptr!");
+
   // apply the fast fading and the beamforming gain
-  rxPsd = m_spectrumLossModel->CalcRxPowerSpectralDensity (rxPsd, txMob, rxMob);
-  NS_LOG_DEBUG ("Average rx power " << 10*log10 (Sum (*rxPsd) * 180e3) << " dB");
+  rxPsd = m_spectrumLossModel->CalcRxPowerSpectralDensity (rxPsd, params.txMob, params.rxMob, params.txAntenna, params.rxAntenna);
+  NS_LOG_DEBUG ("Average rx power " << 10 * log10 (Sum (*rxPsd) * 180e3) << " dB");
 
   // compute the SNR
   NS_LOG_DEBUG ("Average SNR " << 10 * log10 (Sum (*rxPsd) / Sum (*noisePsd)) << " dB");
@@ -231,17 +266,13 @@
   Ptr<PhasedArrayModel> txAntenna = CreateObjectWithAttributes<UniformPlanarArray> ("NumColumns", UintegerValue (2), "NumRows", UintegerValue (2));
   Ptr<PhasedArrayModel> rxAntenna = CreateObjectWithAttributes<UniformPlanarArray> ("NumColumns", UintegerValue (2), "NumRows", UintegerValue (2));
 
-  // initialize the devices in the ThreeGppSpectrumPropagationLossModel
-  m_spectrumLossModel->AddDevice (txDev, txAntenna);
-  m_spectrumLossModel->AddDevice (rxDev, rxAntenna);
-
   // set the beamforming vectors
   DoBeamforming (txDev, txAntenna, rxDev);
   DoBeamforming (rxDev, rxAntenna, txDev);
 
   for (int i = 0; i < floor (simTime / timeRes); i++)
   {
-    Simulator::Schedule (MilliSeconds (timeRes*i), &ComputeSnr, txMob, rxMob, txPow, noiseFigure);
+    Simulator::Schedule (MilliSeconds (timeRes*i), &ComputeSnr, ComputeSnrParams (txMob, rxMob, txPow, noiseFigure, txAntenna, rxAntenna));
   }
 
   Simulator::Run ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/model/half-duplex-ideal-phy.cc ns-3.36/src/spectrum/model/half-duplex-ideal-phy.cc
--- ns-3.35/src/spectrum/model/half-duplex-ideal-phy.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/model/half-duplex-ideal-phy.cc	2022-04-30 18:23:58.146735000 -0700
@@ -255,8 +255,8 @@
   m_phyMacRxEndOkCallback = c;
 }
 
-Ptr<AntennaModel>
-HalfDuplexIdealPhy::GetRxAntenna () const
+Ptr<Object>
+HalfDuplexIdealPhy::GetAntenna () const
 {
   NS_LOG_FUNCTION (this);
   return m_antenna;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/model/half-duplex-ideal-phy.h ns-3.36/src/spectrum/model/half-duplex-ideal-phy.h
--- ns-3.35/src/spectrum/model/half-duplex-ideal-phy.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/model/half-duplex-ideal-phy.h	2022-04-30 18:23:58.146735000 -0700
@@ -105,7 +105,7 @@
   Ptr<MobilityModel> GetMobility () const;
   Ptr<NetDevice> GetDevice () const;
   Ptr<const SpectrumModel> GetRxSpectrumModel () const;
-  Ptr<AntennaModel> GetRxAntenna () const;
+  Ptr<Object> GetAntenna () const;
   void StartRx (Ptr<SpectrumSignalParameters> params);
 
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/model/half-duplex-ideal-phy-signal-parameters.h ns-3.36/src/spectrum/model/half-duplex-ideal-phy-signal-parameters.h
--- ns-3.35/src/spectrum/model/half-duplex-ideal-phy-signal-parameters.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/model/half-duplex-ideal-phy-signal-parameters.h	2022-04-30 18:23:58.146735000 -0700
@@ -46,6 +46,7 @@
 
   /**
    * copy constructor
+   * \param p object to copy
    */
   HalfDuplexIdealPhySignalParameters (const HalfDuplexIdealPhySignalParameters& p);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/model/matrix-based-channel-model.h ns-3.36/src/spectrum/model/matrix-based-channel-model.h
--- ns-3.35/src/spectrum/model/matrix-based-channel-model.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/model/matrix-based-channel-model.h	2022-04-30 18:23:58.146735000 -0700
@@ -54,16 +54,14 @@
   typedef std::vector<PhasedArrayModel::ComplexVector> Complex2DVector; //!< type definition for complex matrices
   typedef std::vector<Complex2DVector> Complex3DVector; //!< type definition for complex 3D matrices
 
-
   /**
    * Data structure that stores a channel realization
    */
   struct ChannelMatrix : public SimpleRefCount<ChannelMatrix>
   {
     Complex3DVector    m_channel; //!< channel matrix H[u][s][n].
-    DoubleVector       m_delay; //!< cluster delay in nanoseconds.
-    Double2DVector     m_angle; //!< cluster angle angle[direction][n], where direction = 0(AOA), 1(ZOA), 2(AOD), 3(ZOD) in degree.
     Time               m_generatedTime; //!< generation time
+    std::pair<uint32_t, uint32_t> m_antennaPair; //!< the first element is the ID of the antenna of the s-node (the antenna of the transmitter when the channel was generated), the second element is ID of the antenna of the u-node antenna (the antenna of the receiver when the channel was generated)
     std::pair<uint32_t, uint32_t> m_nodeIds; //!< the first element is the s-node ID (the transmitter when the channel was generated), the second element is the u-node ID (the receiver when the channel was generated)
 
     /**
@@ -74,20 +72,38 @@
     /**
      * Returns true if the ChannelMatrix object was generated
      * considering node b as transmitter and node a as receiver.
-     * \param aId id of the a node
-     * \param bId id of the b node
+     * \param aAntennaId the ID of the antenna array of the a node
+     * \param bAntennaId the ID of the antenna array of the b node
      * \return true if b is the rx and a is the tx, false otherwise
      */
-    bool IsReverse (const uint32_t aId, const uint32_t bId) const
+    bool IsReverse (uint32_t aAntennaId, uint32_t bAntennaId) const
     {
-      uint32_t sId, uId;
-      std::tie (sId, uId) = m_nodeIds;
-      NS_ASSERT_MSG ((sId == aId && uId == bId) || (sId == bId && uId == aId),
-                      "This matrix represents the channel between " << sId << " and " << uId);
-      return (sId == bId && uId == aId);
+      uint32_t sAntennaId, uAntennaId;
+      std::tie (sAntennaId, uAntennaId) = m_antennaPair;
+      NS_ASSERT_MSG ((sAntennaId == aAntennaId && uAntennaId == bAntennaId) || (sAntennaId == bAntennaId && uAntennaId == aAntennaId),
+                      "This channel matrix does not represent the channel among the antenna arrays for which are provided IDs.");
+      return (sAntennaId == bAntennaId && uAntennaId == aAntennaId);
     }
   };
 
+
+  /**
+   * Data structure that stores channel parameters
+   */
+  struct ChannelParams : public SimpleRefCount<ChannelParams>
+  {
+    Time               m_generatedTime; //!< generation time
+    DoubleVector       m_delay; //!< cluster delay in nanoseconds.
+    Double2DVector     m_angle; //!< cluster angle angle[direction][n], where direction = 0(AOA), 1(ZOA), 2(AOD), 3(ZOD) in degree.
+    DoubleVector m_alpha; //!< alpha term per cluster as described in 3GPP TR 37.885 v15.3.0, Sec. 6.2.3 for calculating doppler
+    DoubleVector m_D; //!< D term per cluster as described in 3GPP TR 37.885 v15.3.0, Sec. 6.2.3 for calculating doppler
+    std::pair<uint32_t, uint32_t> m_nodeIds; //!< the first element is the s-node ID (the transmitter when the channel params were generated), the second element is the u-node ID (the receiver when the channel params were generated generated)
+    /**
+     * Destructor for ChannelParams
+     */
+    virtual ~ChannelParams () = default;
+  };
+
   /**
    * Returns a matrix with a realization of the channel between
    * the nodes with mobility objects passed as input parameters.
@@ -112,14 +128,26 @@
                                                Ptr<const PhasedArrayModel> bAntenna) = 0;
   
   /**
-   * Calculate the channel key using the Cantor function
-   * \param x1 first value
-   * \param x2 second value
-   * \return \f$ (((x1 + x2) * (x1 + x2 + 1))/2) + x2; \f$
+   * Returns a channel parameters structure used to obtain the channel between
+   * the nodes with mobility objects passed as input parameters.
+   *
+   * \param aMob mobility model of the a device
+   * \param bMob mobility model of the b device
+   * \return the channel matrix
+   */
+  virtual Ptr<const ChannelParams> GetParams (Ptr<const MobilityModel> aMob,
+                                              Ptr<const MobilityModel> bMob) const = 0;
+
+  /**
+   * Generate a unique value for the pair of unsigned integer of 32 bits,
+   * where the order does not matter, i.e., the same value will be returned for (a,b) and (b,a).
+   * \param a the first value
+   * \param b the second value
+   * \return return an integer representing a unique value for the pair of values
    */
-  static constexpr uint32_t GetKey (uint32_t x1, uint32_t x2)
+  static uint64_t GetKey (uint32_t a, uint32_t b)
   {
-   return (((x1 + x2) * (x1 + x2 + 1)) / 2) + x2;
+   return (uint64_t) std::min (a, b) << 32 | std::max (a, b);
   }
 
   static const uint8_t AOA_INDEX = 0; //!< index of the AOA value in the m_angle array
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/model/multi-model-spectrum-channel.cc ns-3.36/src/spectrum/model/multi-model-spectrum-channel.cc
--- ns-3.35/src/spectrum/model/multi-model-spectrum-channel.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/model/multi-model-spectrum-channel.cc	2022-04-30 18:23:58.146735000 -0700
@@ -106,16 +106,10 @@
 }
 
 void
-MultiModelSpectrumChannel::AddRx (Ptr<SpectrumPhy> phy)
+MultiModelSpectrumChannel::RemoveRx (Ptr<SpectrumPhy> phy)
 {
   NS_LOG_FUNCTION (this << phy);
 
-  Ptr<const SpectrumModel> rxSpectrumModel = phy->GetRxSpectrumModel ();
-
-  NS_ASSERT_MSG ((0 != rxSpectrumModel), "phy->GetRxSpectrumModel () returned 0. Please check that the RxSpectrumModel is already set for the phy before calling MultiModelSpectrumChannel::AddRx (phy)");
-
-  SpectrumModelUid_t rxSpectrumModelUid = rxSpectrumModel->GetUid ();
-
   // remove a previous entry of this phy if it exists
   // we need to scan for all rxSpectrumModel values since we don't
   // know which spectrum model the phy had when it was previously added
@@ -130,8 +124,22 @@
           rxInfoIterator->second.m_rxPhys.erase (phyIt);
           --m_numDevices;
           break; // there should be at most one entry
-        }       
+        }
     }
+}
+
+void
+MultiModelSpectrumChannel::AddRx (Ptr<SpectrumPhy> phy)
+{
+  NS_LOG_FUNCTION (this << phy);
+
+  Ptr<const SpectrumModel> rxSpectrumModel = phy->GetRxSpectrumModel ();
+
+  NS_ASSERT_MSG ((0 != rxSpectrumModel), "phy->GetRxSpectrumModel () returned 0. Please check that the RxSpectrumModel is already set for the phy before calling MultiModelSpectrumChannel::AddRx (phy)");
+
+  SpectrumModelUid_t rxSpectrumModelUid = rxSpectrumModel->GetUid ();
+
+  RemoveRx (phy);
 
   ++m_numDevices;
 
@@ -269,6 +277,19 @@
 
           if ((*rxPhyIterator) != txParams->txPhy)
             {
+              Ptr<NetDevice> rxNetDevice = (*rxPhyIterator)->GetDevice ();
+              Ptr<NetDevice> txNetDevice = txParams->txPhy->GetDevice ();
+
+              if (rxNetDevice && txNetDevice)
+                {
+                  // we assume that devices are attached to a node
+                  if (rxNetDevice->GetNode()->GetId() == txNetDevice->GetNode()->GetId())
+                    {
+                      NS_LOG_DEBUG ("Skipping the pathloss calculation among different antennas of the same node, not supported yet by any pathloss model in ns-3.");
+                      continue;
+                    }
+                }
+
               NS_LOG_LOGIC ("copying signal parameters " << txParams);
               Ptr<SpectrumSignalParameters> rxParams = txParams->Copy ();
               rxParams->psd = Copy<SpectrumValue> (convertedTxPowerSpectrum);
@@ -289,7 +310,7 @@
                       NS_LOG_LOGIC ("txAntennaGain = " << txAntennaGain << " dB");
                       pathLossDb -= txAntennaGain;
                     }
-                  Ptr<AntennaModel> rxAntenna = (*rxPhyIterator)->GetRxAntenna ();
+                  Ptr<AntennaModel> rxAntenna = DynamicCast<AntennaModel>((*rxPhyIterator)->GetAntenna ());
                   if (rxAntenna != 0)
                     {
                       Angles rxAngles (txMobility->GetPosition (), receiverMobility->GetPosition ());
@@ -320,6 +341,15 @@
                     {
                       rxParams->psd = m_spectrumPropagationLoss->CalcRxPowerSpectralDensity (rxParams->psd, txMobility, receiverMobility);
                     }
+                  else if (m_phasedArraySpectrumPropagationLoss)
+                    {
+                      Ptr<const PhasedArrayModel> txPhasedArrayModel = DynamicCast<PhasedArrayModel> (txParams->txPhy->GetAntenna ());
+                      Ptr<const PhasedArrayModel> rxPhasedArrayModel = DynamicCast<PhasedArrayModel> ((*rxPhyIterator)->GetAntenna ());
+
+                      NS_ASSERT_MSG (txPhasedArrayModel && rxPhasedArrayModel, "PhasedArrayModel instances should be installed at both TX and RX SpectrumPhy in order to use PhasedArraySpectrumPropagationLoss.");
+
+                      rxParams->psd = m_phasedArraySpectrumPropagationLoss->CalcRxPowerSpectralDensity (rxParams->psd, txMobility, receiverMobility, txPhasedArrayModel, rxPhasedArrayModel);
+                     }
 
                   if (m_propagationDelay)
                     {
@@ -327,11 +357,10 @@
                     }
                 }
 
-              Ptr<NetDevice> netDev = (*rxPhyIterator)->GetDevice ();
-              if (netDev)
+              if (rxNetDevice)
                 {
                   // the receiver has a NetDevice, so we expect that it is attached to a Node
-                  uint32_t dstNode =  netDev->GetNode ()->GetId ();
+                  uint32_t dstNode = rxNetDevice->GetNode ()->GetId ();
                   Simulator::ScheduleWithContext (dstNode, delay, &MultiModelSpectrumChannel::StartRx, this,
                                                   rxParams, *rxPhyIterator);
                 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/model/multi-model-spectrum-channel.h ns-3.36/src/spectrum/model/multi-model-spectrum-channel.h
--- ns-3.35/src/spectrum/model/multi-model-spectrum-channel.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/model/multi-model-spectrum-channel.h	2022-04-30 18:23:58.146735000 -0700
@@ -116,6 +116,7 @@
   static TypeId GetTypeId (void);
 
   // inherited from SpectrumChannel
+  virtual void RemoveRx (Ptr<SpectrumPhy> phy);
   virtual void AddRx (Ptr<SpectrumPhy> phy);
   virtual void StartTx (Ptr<SpectrumSignalParameters> params);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/model/phased-array-spectrum-propagation-loss-model.cc ns-3.36/src/spectrum/model/phased-array-spectrum-propagation-loss-model.cc
--- ns-3.35/src/spectrum/model/phased-array-spectrum-propagation-loss-model.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/spectrum/model/phased-array-spectrum-propagation-loss-model.cc	2022-04-30 18:23:58.146735000 -0700
@@ -0,0 +1,80 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2021 CTTC
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ */
+
+
+#include "phased-array-spectrum-propagation-loss-model.h"
+#include <ns3/log.h>
+#include <ns3/phased-array-model.h>
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("PhasedArraySpectrumPropagationLossModel");
+
+NS_OBJECT_ENSURE_REGISTERED (PhasedArraySpectrumPropagationLossModel);
+
+PhasedArraySpectrumPropagationLossModel::PhasedArraySpectrumPropagationLossModel ()
+  : m_next (0)
+{
+}
+
+PhasedArraySpectrumPropagationLossModel::~PhasedArraySpectrumPropagationLossModel ()
+{
+}
+
+void
+PhasedArraySpectrumPropagationLossModel::DoDispose ()
+{
+  m_next = 0;
+}
+
+TypeId
+PhasedArraySpectrumPropagationLossModel::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::PhasedArraySpectrumPropagationLossModel")
+    .SetParent<Object> ()
+    .SetGroupName ("Spectrum")
+  ;
+  return tid;
+}
+
+
+void PhasedArraySpectrumPropagationLossModel::SetNext (Ptr<PhasedArraySpectrumPropagationLossModel> next)
+{
+  m_next = next;
+}
+
+Ptr<SpectrumValue>
+PhasedArraySpectrumPropagationLossModel::CalcRxPowerSpectralDensity (Ptr<const SpectrumValue> txPsd,
+                                                                     Ptr<const MobilityModel> a,
+                                                                     Ptr<const MobilityModel> b,
+                                                                     Ptr<const PhasedArrayModel> aPhasedArrayModel,
+                                                                     Ptr<const PhasedArrayModel> bPhasedArrayModel) const
+{
+  // Here we assume that all the models in the chain of models are of type
+  // PhasedArraySpectrumPropagationLossModel that provides the implementation of
+  // this function, i.e. has phased array model of TX and RX as parameters
+  Ptr<SpectrumValue> rxPsd = DoCalcRxPowerSpectralDensity (txPsd, a, b, aPhasedArrayModel, bPhasedArrayModel);
+  if (m_next != 0)
+    {
+      rxPsd = m_next->CalcRxPowerSpectralDensity (rxPsd, a, b, aPhasedArrayModel, bPhasedArrayModel);
+    }
+  return rxPsd;
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/model/phased-array-spectrum-propagation-loss-model.h ns-3.36/src/spectrum/model/phased-array-spectrum-propagation-loss-model.h
--- ns-3.35/src/spectrum/model/phased-array-spectrum-propagation-loss-model.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/spectrum/model/phased-array-spectrum-propagation-loss-model.h	2022-04-30 18:23:58.146735000 -0700
@@ -0,0 +1,120 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2021 CTTC
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ */
+
+#ifndef PHASED_ARRAY_SPECTRUM_PROPAGATION_LOSS_MODEL_H
+#define PHASED_ARRAY_SPECTRUM_PROPAGATION_LOSS_MODEL_H
+
+
+#include <ns3/object.h>
+#include <ns3/mobility-model.h>
+#include <ns3/spectrum-value.h>
+#include <ns3/phased-array-model.h>
+
+namespace ns3 {
+
+
+/**
+ * \ingroup spectrum
+ *
+ * \brief spectrum-aware propagation loss model that is
+ * compatible with PhasedArrayModel type of ns-3 antenna
+ *
+ * Interface for propagation loss models to be adopted when
+ * transmissions are modeled with a power spectral density by means of
+ * the SpectrumValue class, and when PhasedArrayModel type of atenna
+ * is being used for TX and RX.
+ *
+ */
+class PhasedArraySpectrumPropagationLossModel : public Object
+{
+public:
+  PhasedArraySpectrumPropagationLossModel ();
+  virtual ~PhasedArraySpectrumPropagationLossModel ();
+
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId ();
+
+  /**
+   * Used to chain various instances of PhasedArraySpectrumPropagationLossModel
+   *
+   * @param next
+   */
+  void SetNext (Ptr<PhasedArraySpectrumPropagationLossModel> next);
+
+  /**
+   * This method is to be called to calculate
+   *
+   * @param txPsd the SpectrumValue representing the power spectral
+   * density of the transmission. Watt units are to be used for radio
+   * communications, and Pascal units for acoustic communications
+   * (e.g., underwater).
+   *
+   * @param a sender mobility
+   * @param b receiver mobility
+   * @param aPhasedArrayModel the instance of the phased antenna array of the sender
+   * @param bPhasedArrayModel the instance of the phased antenna array of the receiver
+   *
+   * @return set of values Vs frequency representing the received
+   * power in the same units used for the txPower parameter.
+   */
+  Ptr<SpectrumValue> CalcRxPowerSpectralDensity (Ptr<const SpectrumValue> txPsd,
+                                                 Ptr<const MobilityModel> a,
+                                                 Ptr<const MobilityModel> b,
+                                                 Ptr<const PhasedArrayModel> aPhasedArrayModel,
+                                                 Ptr<const PhasedArrayModel> bPhasedArrayModel) const;
+
+protected:
+  virtual void DoDispose ();
+
+
+private:
+  /**
+   *
+   * @param txPsd set of values Vs frequency representing the
+   * transmission power. See SpectrumChannel for details.
+   * @param a sender mobility
+   * @param b receiver mobility
+   * @param aPhasedArrayModel the instance of the phased antenna array of the sender
+   * @param bPhasedArrayModel the instance of the phased antenna array of the receiver
+   *
+   * @return set of values Vs frequency representing the received
+   * power in the same units used for the txPower parameter.
+   */
+  virtual Ptr<SpectrumValue> DoCalcRxPowerSpectralDensity (Ptr<const SpectrumValue> txPsd,
+                                                           Ptr<const MobilityModel> a,
+                                                           Ptr<const MobilityModel> b,
+                                                           Ptr<const PhasedArrayModel> aPhasedArrayModel,
+                                                           Ptr<const PhasedArrayModel> bPhasedArrayModel) const = 0;
+
+  Ptr<PhasedArraySpectrumPropagationLossModel> m_next; //!< PhasedArraySpectrumPropagationLossModel chained to this one.
+};
+
+
+
+
+
+
+} // namespace ns3
+
+#endif /* PHASED_ARRAY_SPECTRUM_PROPAGATION_LOSS_MODEL_H */
+
+
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/model/single-model-spectrum-channel.cc ns-3.36/src/spectrum/model/single-model-spectrum-channel.cc
--- ns-3.35/src/spectrum/model/single-model-spectrum-channel.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/model/single-model-spectrum-channel.cc	2022-04-30 18:23:58.146735000 -0700
@@ -34,6 +34,7 @@
 #include <ns3/antenna-model.h>
 #include <ns3/angles.h>
 
+#include <algorithm>
 
 #include "single-model-spectrum-channel.h"
 
@@ -72,6 +73,17 @@
 
 
 void
+SingleModelSpectrumChannel::RemoveRx (Ptr<SpectrumPhy> phy)
+{
+  NS_LOG_FUNCTION (this << phy);
+  auto it = std::find (begin (m_phyList), end (m_phyList), phy);
+  if (it != std::end (m_phyList))
+    {
+      m_phyList.erase (it);
+    }
+}
+
+void
 SingleModelSpectrumChannel::AddRx (Ptr<SpectrumPhy> phy)
 {
   NS_LOG_FUNCTION (this << phy);
@@ -110,6 +122,19 @@
        rxPhyIterator != m_phyList.end ();
        ++rxPhyIterator)
     {
+      Ptr<NetDevice> rxNetDevice = (*rxPhyIterator)->GetDevice ();
+      Ptr<NetDevice> txNetDevice = txParams->txPhy->GetDevice ();
+
+      if (rxNetDevice && txNetDevice)
+        {
+          // we assume that devices are attached to a node
+          if (rxNetDevice->GetNode()->GetId() == txNetDevice->GetNode()->GetId())
+            {
+              NS_LOG_DEBUG ("Skipping the pathloss calculation among different antennas of the same node, not supported yet by any pathloss model in ns-3.");
+              continue;
+            }
+        }
+
       if ((*rxPhyIterator) != txParams->txPhy)
         {
           Time delay  = MicroSeconds (0);
@@ -131,7 +156,7 @@
                   NS_LOG_LOGIC ("txAntennaGain = " << txAntennaGain << " dB");
                   pathLossDb -= txAntennaGain;
                 }
-              Ptr<AntennaModel> rxAntenna = (*rxPhyIterator)->GetRxAntenna ();
+              Ptr<AntennaModel> rxAntenna = DynamicCast<AntennaModel>((*rxPhyIterator)->GetAntenna ());
               if (rxAntenna != 0)
                 {
                   Angles rxAngles (senderMobility->GetPosition (), receiverMobility->GetPosition ());
@@ -170,11 +195,10 @@
             }
 
 
-          Ptr<NetDevice> netDev = (*rxPhyIterator)->GetDevice ();
-          if (netDev)
+          if (rxNetDevice)
             {
               // the receiver has a NetDevice, so we expect that it is attached to a Node
-              uint32_t dstNode =  netDev->GetNode ()->GetId ();
+              uint32_t dstNode =  rxNetDevice->GetNode ()->GetId ();
               Simulator::ScheduleWithContext (dstNode, delay, &SingleModelSpectrumChannel::StartRx, this, rxParams, *rxPhyIterator);
             }
           else
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/model/single-model-spectrum-channel.h ns-3.36/src/spectrum/model/single-model-spectrum-channel.h
--- ns-3.35/src/spectrum/model/single-model-spectrum-channel.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/model/single-model-spectrum-channel.h	2022-04-30 18:23:58.146735000 -0700
@@ -50,6 +50,7 @@
   static TypeId GetTypeId (void);
 
   // inherited from SpectrumChannel
+  virtual void RemoveRx (Ptr<SpectrumPhy> phy);
   virtual void AddRx (Ptr<SpectrumPhy> phy);
   virtual void StartTx (Ptr<SpectrumSignalParameters> params);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/model/spectrum-analyzer.cc ns-3.36/src/spectrum/model/spectrum-analyzer.cc
--- ns-3.35/src/spectrum/model/spectrum-analyzer.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/model/spectrum-analyzer.cc	2022-04-30 18:23:58.146735000 -0700
@@ -142,8 +142,8 @@
 }
 
 
-Ptr<AntennaModel>
-SpectrumAnalyzer::GetRxAntenna () const
+Ptr<Object>
+SpectrumAnalyzer::GetAntenna () const
 {
   return m_antenna;
 }
